#include <iostream>
#include <BPatch.h>
#include <BPatch_function.h>
#include <BPatch_point.h>

using namespace std;

int
main(int argc, const char* argv[])
{
    if (argc < 2) {
        clog << "ERROR: need to specify an app to run" << endl;
        return 1;
    }

    BPatch bpatch;
    BPatch_process *proc = bpatch.processCreate(argv[1], &argv[1]);
    if (!proc) {
        clog << "ERROR: couldn't create process" << endl;
        return 1;
    }

    vector<BPatch_function *> printfFuncs;
    vector<BPatch_snippet *> printfArgs;
    proc->getImage()->findFunction("printf", printfFuncs);
    if (printfFuncs.empty()) {
        clog << "ERROR: couldn't find printf" << endl;
        return 1;
    }
    printfArgs.push_back(new BPatch_constExpr("main!\n"));
    BPatch_funcCallExpr printfCall(*printfFuncs[0], printfArgs);

    std::vector<BPatch_function *> functions;
    proc->getImage()->findFunction("main", functions);
    if (functions.empty()) {
        clog << "ERROR: couldn't find main" << endl;
        return 1;
    }
    proc->insertSnippet(printfCall,
            *functions[0]->findPoint(BPatch_entry));

    proc->continueExecution();
    while (!proc->isTerminated())
        bpatch.waitForStatusChange();

    return 0;
}
